"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _safeExtend = require("safe-extend");

var _safeExtend2 = _interopRequireDefault(_safeExtend);

var _defaultSettings = require("./defaultSettings");

var _defaultSettings2 = _interopRequireDefault(_defaultSettings);

var _util = require("./util");

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var reactDefaultValue = function reactDefaultValue(WrappedComponent, settings) {
    settings = (0, _safeExtend2.default)(true, _defaultSettings2.default, settings);
    // input unifrom array
    if (!Array.isArray(settings.input)) {
        settings.input = [settings.input];
    }
    // output unifrom array
    if (!Array.isArray(settings.output)) {
        settings.output = [settings.output];
    }

    var ReactDefaultValue = function (_Component) {
        _inherits(ReactDefaultValue, _Component);

        function ReactDefaultValue(props) {
            _classCallCheck(this, ReactDefaultValue);

            var _this = _possibleConstructorReturn(this, (ReactDefaultValue.__proto__ || Object.getPrototypeOf(ReactDefaultValue)).call(this, props));

            _this.transInput = function () {
                var self = _this;
            };

            var self = _this;
            self.inputDefaultKey = [
                /*
                    "defaultValue",
                    "defaultShow",
                */
            ];
            settings.input.forEach(function (key) {
                var name = _util2.default.getInputName(key);
                self.inputDefaultKey.push("default" + _util2.default.firstUpperCase(name));
            });
            self.state = {};
            var inputIndex = 0;
            self.inputDefaultKey.forEach(function (key, index) {
                var value = props[key];
                var inputDefaultValue = void 0;
                if (_typeof(settings.input[index]) === 'object') {
                    inputDefaultValue = settings.input[index].default;
                }
                if (typeof value === 'undefined') {
                    value = inputDefaultValue;
                }
                self.state[key] = value;
            });
            return _this;
        }

        _createClass(ReactDefaultValue, [{
            key: "render",
            value: function render() {
                var self = this;
                var proxyProps = {};
                var isControlled = settings.input.some(function (key) {
                    return typeof self.props[key] !== 'undefined';
                });
                if (!isControlled) {
                    settings.input.forEach(function (key, index) {
                        var name = _util2.default.getInputName(key);
                        proxyProps[name] = self.state[self.inputDefaultKey[index]];
                    });
                    settings.output.forEach(function (item, index) {
                        var key = void 0;
                        var sync = void 0;
                        switch (typeof item === "undefined" ? "undefined" : _typeof(item)) {
                            case 'string':
                                key = item;
                                sync = function sync() {
                                    for (var _len = arguments.length, arg = Array(_len), _key = 0; _key < _len; _key++) {
                                        arg[_key] = arguments[_key];
                                    }

                                    _util2.default.defaultSync(arg, function (data) {
                                        self.setState(_defineProperty({}, self.inputDefaultKey[index], data));
                                    });
                                };
                                break;
                            case 'object':
                                key = item.key;
                                sync = function sync() {
                                    for (var _len2 = arguments.length, arg = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                                        arg[_key2] = arguments[_key2];
                                    }

                                    self.setState(_defineProperty({}, self.inputDefaultKey[index], item.sync.apply({}, arg)));
                                };
                                break;
                            default:
                                var typeErrorMessage = 'react-defaultvalue(npm): ' + 'reactDefaultValue(App, settings) settings.output[item]' + ' item must be string or object';
                                throw new Error(typeErrorMessage);
                        }
                        proxyProps[key] = sync;
                    });
                }
                var forwardedRef = self.props.forwardedRef;

                return require("react").createElement(WrappedComponent, _extends({
                    ref: forwardedRef
                }, self.props, proxyProps));
            }
        }]);

        return ReactDefaultValue;
    }(_react.Component);
    // https://github.com/airbnb/enzyme/pull/1513
    // 因为 Enzyme 不支持 forwardRef 所以加一个判断便于在单元测试中测试


    var globalVar = global || {};
    if (globalVar.isTestDoNotUseForward) {
        return ReactDefaultValue;
    }
    if (typeof _react2.default.forwardRef === 'undefined') {
        console.warn('react-defaultvalue(npm): You need to update react > 16.3.0\r\n Forwardref  https://reactjs.org/blog/2018/03/29/react-v-16-3.html#forwardref-api');
        return ReactDefaultValue;
    } else {
        return _react2.default.forwardRef(function (props, ref) {
            return require("react").createElement(ReactDefaultValue, _extends({}, props, { forwardedRef: ref }));
        });
    }
};
module.exports = reactDefaultValue;